import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.betacraft.Wrapper;
import org.betacraft.launcher.BC;
import org.betacraft.launcher.DownloadResult;
import org.betacraft.launcher.Launcher;
import org.betacraft.launcher.Logger;
import org.betacraft.launcher.ReleaseJson;

public class NSSS_1 extends Wrapper {

	public NSSS_1(String user, String ver_prefix, String version, String sessionid, String mainFolder, Integer height,
			Integer width, Boolean RPC, String launchMethod, String server, String mppass, String USR, String VER,
			Image img, ArrayList addons) {
		super(user, ver_prefix, version, sessionid, mainFolder, height, width, RPC, launchMethod, server, mppass, USR, VER, img,
				addons);
	}

	@Override
	public void setPrefixAndLoadMainClass(URL[] url) {
		classLoader = new BCClassLoader(url);
		try {
			appletClass = classLoader.loadClass("com.mojang.minecraft.MinecraftApplet");
			applet = (Applet) appletClass.newInstance();
		} catch (Exception ex) {
			ex.printStackTrace();
			Logger.printException(ex);
		}
	}

	@Override
	public void play() {
		try {
			System.clearProperty("http.proxyHost");
			System.clearProperty("http.proxyPort");
			File a11201 = new File(BC.get() + "versions", "a1.1.2_01.jar");
			if (!a11201.exists()) {
				ReleaseJson json = new ReleaseJson("a1.1.2_01", false);
				JFrame frame = new JFrame("Downloading dependencies...");
				frame.setLayout(new GridBagLayout());
				frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
				JLabel infolabel = new JLabel("Downloading: a1.1.2_01 (" + json.getDownloadURL() + ")");
				GridBagConstraints constr = new GridBagConstraints();

				constr.gridx = 0;
				constr.gridy = 0;
				constr.fill = GridBagConstraints.HORIZONTAL;
				constr.gridwidth = 1;
				constr.weightx = 1.0;
				constr.insets = new Insets(10, 10, 10, 10);

				frame.add(infolabel, constr);
				frame.pack();

				frame.setIconImage(this.icon);
				frame.setLocationRelativeTo(null);
				frame.setVisible(true);
				if (Launcher.download(json.getDownloadURL(), a11201) == DownloadResult.FAILED_WITHOUT_BACKUP) {
					infolabel.setText("Failed to download! Check your Internet connection!");
					frame.setTitle("Failed!");
				} else {
					frame.setVisible(false);
				}
			}
			String nativesPath = BC.get() + "bin/natives";

			// Glue everything Minecraft needs for running
			String file = BC.get() + "versions/a1.1.2_01.jar";
			String file1 = BC.get() + "versions/" + version + ".jar";
			String file2 = BC.get() + "bin/lwjgl.jar";
			String file3 = BC.get() + "bin/lwjgl_util.jar";
			String file4 = BC.get() + "bin/jinput.jar";
			String file5 = BC.get() + "bin/jutils.jar";

			System.setProperty("org.lwjgl.librarypath", nativesPath);
			System.setProperty("net.java.games.input.librarypath", nativesPath);

			final URL[] url = new URL[6];
			url[0] = new File(file).toURI().toURL();
			url[1] = new File(file1).toURI().toURL();
			url[2] = new File(file2).toURI().toURL();
			url[3] = new File(file3).toURI().toURL();
			url[4] = new File(file4).toURI().toURL();
			url[5] = new File(file5).toURI().toURL();

			setPrefixAndLoadMainClass(url);

			// Replace the main game folder to .betacraft
			// Skip versions prior to Indev. They don't support changing game folders.
			this.setGameFolder();

			// Make a frame for the game
			gameFrame = new Frame();
			gameFrame.setTitle(ver_prefix);
			gameFrame.setIconImage(this.icon);
			gameFrame.setBackground(Color.BLACK);

			// This is needed for the window size
			final JPanel panel = new JPanel();
			panel.setLayout(new BorderLayout());
			gameFrame.setLayout(new BorderLayout());
			panel.setBackground(Color.BLACK);
			panel.setPreferredSize(new Dimension(width, height)); // 854, 480

			gameFrame.add(panel, "Center");
			gameFrame.pack();
			gameFrame.setLocationRelativeTo(null);
			gameFrame.setVisible(true);

			applet.setStub(this);
			applet.resize(width, height);
			applet.setMinimumSize(new Dimension(width, height));

			this.addHooks();

			// Add game's applet to this window
			this.setLayout(new BorderLayout());
			this.add(applet, "Center");
			gameFrame.removeAll();
			gameFrame.setLayout(new BorderLayout());
			gameFrame.add(this, "Center");
			this.init();
			active = true;
			this.start();
			gameFrame.validate();
			// Start Discord RPC
			if (discord) discordThread.start();
		} catch (Exception ex) {
			System.out.println("A critical error has occurred!");
			System.out.print(ex.toString());
		}
	}
}
